; !!! For checking with unaligned string, use next macro:
MisAlign =	1	; add 9 bytes to the src pointer
CrashIt =	0	; overrides MisAlign - the "SSE1" algos will bang their head against the VirtualAlloc boundary

.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm
LOOP_COUNT	= 2000000

a16 MACRO
	align 16
	REPEAT 16
		retn 0		; tell the CPU there is nothing interesting before the proc
	ENDM
ENDM

cycles MACRO  src,nom, algo, extra
	invoke Sleep, SleepMs
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		push offset Src
        push Num
		call &algo
	counter_end
	print str$(eax), 9, "cycles for &algo &extra&", 13, 10
ENDM




.data
align 16
Src	dd 100 Dup(0)
Num dd 0FFFFFFFFh,0
vaPtr	dd 0
align 16
chartabL dw "00","10","20","30","40","50","60","70","80","90"
                dw "01","11","21","31","41","51","61","71","81","91"
                dw "02","12","22","32","42","52","62","72","82","92"
                dw "03","13","23","33","43","53","63","73","83","93"
                dw "04","14","24","34","44","54","64","74","84","94"
                dw "05","15","25","35","45","55","65","75","85","95"
                dw "06","16","26","36","46","56","66","76","86","96"
                dw "07","17","27","37","47","57","67","77","87","97"
                dw "08","18","28","38","48","58","68","78","88","98"
                dw "09","19","29","39","49","59","69","79","89","99"

.code
start:
	push 1
	call ShowCpu						; print brand string and SSE level

	rct = 4
	SleepMs = 20

	REPEAT rct
		push eax
		cycles Num,offset Src,  ltoa_exLingo
		cycles Num, offset Src, ltoa_exHutch
		cycles Num, offset Src, ltoa_ex
		print chr$(13, 10)
	ENDM
	add esp, rct*4

	inkey chr$(13, 10, "--- ok ---", 13)
	exit

a16
ltoa_ex_s:
ltoa_ex proc ;  LongVar:DWORD,answer:DWORD
  ; --------------------------------------------------------------------------------
  ; this algorithm was written by Paul Dixon and has been converted to MASM notation
  ; --------------------------------------------------------------------------------
	push esi
    push edi

    mov eax, [esp+1*4+2*4]   ;LongVar            ; get number
    mov ecx, [esp+2*4+2*4]  ; answer             ; get pointer to answer string
    jmp over
      
    chartab:
      dd "00","10","20","30","40","50","60","70","80","90"
      dd "01","11","21","31","41","51","61","71","81","91"
      dd "02","12","22","32","42","52","62","72","82","92"
      dd "03","13","23","33","43","53","63","73","83","93"
      dd "04","14","24","34","44","54","64","74","84","94"
      dd "05","15","25","35","45","55","65","75","85","95"
      dd "06","16","26","36","46","56","66","76","86","96"
      dd "07","17","27","37","47","57","67","77","87","97"
      dd "08","18","28","38","48","58","68","78","88","98"
      dd "09","19","29","39","49","59","69","79","89","99"

  over:
    ; on entry eax=number to convert, ecx=pointer to answer buffer (minimum 12 bytes)
    ; on exit, eax,ecx,edx are undefined, all other registers are preserved.
    ; answer is in location pointed to by ecx on entry

  signed:
    ; do a signed DWORD to ASCII
    or eax,eax                          ; test sign
    jns udword                          ; if +ve, continue as for unsigned
    neg eax                             ; else, make number positive
    mov byte ptr [ecx],"-"              ; include the - sign
    inc ecx                             ; update the pointer

  udword:
    ; unsigned DWORD to ASCII
    mov esi,ecx                         ; get pointer to answer
    mov edi,eax                         ; save a copy of the number

    mov edx, 0D1B71759h                 ; =2^45\10000    13 bit extra shift
    mul edx                             ; gives 6 high digits in edx

    mov eax, 068DB9h                    ; =2^32\10000+1

    shr edx,13                          ; correct for multiplier offset used to give better accuracy
    jz short skiphighdigits             ; if zero then don't need to process the top 6 digits

    mov ecx,edx                         ; get a copy of high digits
    imul ecx,10000                      ; scale up high digits
    sub edi,ecx                         ; subtract high digits from original. EDI now = lower 4 digits

    mul edx                             ; get first 2 digits in edx
    mov ecx,100                         ; load ready for later

    jnc short next1                     ; if zero, supress them by ignoring
    cmp edx,9                           ; 1 digit or 2?
    ja  short ZeroSupressed             ; 2 digits, just continue with pairs of digits to the end

    mov edx,chartab[edx*4]              ; look up 2 digits
    mov [esi],dh                        ; but only write the 1 we need, supress the leading zero
    inc esi                             ; update pointer by 1
    jmp short ZS1                       ; continue with pairs of digits to the end

  next1:
    mul ecx                             ; get next 2 digits
    jnc short next2                     ; if zero, supress them by ignoring
    cmp edx,9                           ; 1 digit or 2?
    ja  short ZS1a                      ; 2 digits, just continue with pairs of digits to the end

    mov edx,chartab[edx*4]              ; look up 2 digits
    mov [esi],dh                        ; but only write the 1 we need, supress the leading zero
    inc esi                             ; update pointer by 1
    jmp short ZS2                       ; continue with pairs of digits to the end

  next2:
    mul ecx                             ; get next 2 digits
    jnc short next3                     ; if zero, supress them by ignoring
    cmp edx,9                           ; 1 digit or 2?
    ja  short ZS2a                      ; 2 digits, just continue with pairs of digits to the end
     
    mov edx,chartab[edx*4]              ; look up 2 digits
    mov [esi],dh                        ; but only write the 1 we need, supress the leading zero
    inc esi                             ; update pointer by 1
    jmp short ZS3                       ; continue with pairs of digits to the end

  next3:

  skiphighdigits:
    mov eax,edi                         ; get lower 4 digits

    mov ecx,100

    mov edx,28F5C29h                    ; 2^32\100 +1
    mul edx
    jnc short next4                     ; if zero, supress them by ignoring
    cmp edx,9                           ; 1 digit or 2?
    ja  short ZS3a                      ; 2 digits, just continue with pairs of digits to the end

    mov edx,chartab[edx*4]              ; look up 2 digits
    mov [esi],dh                        ; but only write the 1 we need, supress the leading zero
    inc esi                             ; update pointer by 1
    jmp short  ZS4                      ; continue with pairs of digits to the end

    next4:
    mul ecx                             ; this is the last pair so don; t supress a single zero
    cmp edx,9                           ; 1 digit or 2?
    ja  short ZS4a                      ; 2 digits, just continue with pairs of digits to the end

    mov edx,chartab[edx*4]              ; look up 2 digits
    mov [esi],dh                        ; but only write the 1 we need, supress the leading zero
    mov byte ptr [esi+1],0              ; zero terminate string

    jmp short  xit                      ; all done

  ZeroSupressed:
    mov edx,chartab[edx*4]              ; look up 2 digits
    mov [esi],dx
    add esi,2                           ; write them to answer

  ZS1:
    mul ecx                             ; get next 2 digits
    ZS1a:
    mov edx,chartab[edx*4]              ; look up 2 digits
    mov [esi],dx                        ; write them to answer
    add esi,2

  ZS2:
    mul ecx                             ; get next 2 digits
    ZS2a:
    mov edx,chartab[edx*4]              ; look up 2 digits
    mov [esi],dx                        ; write them to answer
    add esi,2

  ZS3:
    mov eax,edi                         ; get lower 4 digits
    mov edx,28F5C29h                    ; 2^32\100 +1
    mul edx                             ; edx= top pair
    ZS3a:
    mov edx,chartab[edx*4]              ; look up 2 digits
    mov [esi],dx                        ; write to answer
    add esi,2                           ; update pointer

  ZS4:
    mul ecx                             ; get final 2 digits
    ZS4a:
    mov edx,chartab[edx*4]              ; look them up
    mov [esi],dx                        ; write to answer

    mov byte ptr [esi+2],0              ; zero terminate string

  xit:
  sdwordend:
    pop edi
    pop esi
    ret 2*4
ltoa_ex endp
ltoa_ex_endp:

a16
ltoa_exHutch_s:
ltoa_exHutch proc ;   LongVar:DWORD,answer:DWORD
	 ; --------------------------------------------------------------------------------
  ; this algorithm was written by Paul Dixon and has been converted to MASM notation
  ; --------------------------------------------------------------------------------
    push esi
    push edi

    mov eax, [esp+4+8]          ; LongVar            ; get number
    mov ecx, [esp+8+8]          ; answer             ; get pointer to answer string
    jmp over

    align 16
    chartab:
      dd "00","10","20","30","40","50","60","70","80","90"
      dd "01","11","21","31","41","51","61","71","81","91"
      dd "02","12","22","32","42","52","62","72","82","92"
      dd "03","13","23","33","43","53","63","73","83","93"
      dd "04","14","24","34","44","54","64","74","84","94"
      dd "05","15","25","35","45","55","65","75","85","95"
      dd "06","16","26","36","46","56","66","76","86","96"
      dd "07","17","27","37","47","57","67","77","87","97"
      dd "08","18","28","38","48","58","68","78","88","98"
      dd "09","19","29","39","49","59","69","79","89","99"

  over:
    ; on entry eax=number to convert, ecx=pointer to answer buffer (minimum 12 bytes)
    ; on exit, eax,ecx,edx are undefined, all other registers are preserved.
    ; answer is in location pointed to by ecx on entry

  signed:
    ; do a signed DWORD to ASCII
    or eax,eax                          ; test sign
    jns udword                          ; if +ve, continue as for unsigned
    neg eax                             ; else, make number positive
    mov byte ptr [ecx],"-"              ; include the - sign
    add ecx, 1                          ; update the pointer

  udword:
    ; unsigned DWORD to ASCII
    mov esi,ecx                         ; get pointer to answer
    mov edi,eax                         ; save a copy of the number

    mov edx, 0D1B71759h                 ; =2^45\10000    13 bit extra shift
    mul edx                             ; gives 6 high digits in edx

    mov eax, 068DB9h                    ; =2^32\10000+1

    shr edx,13                          ; correct for multiplier offset used to give better accuracy
    jz skiphighdigits                   ; if zero then don't need to process the top 6 digits

    mov ecx,edx                         ; get a copy of high digits
    imul ecx,10000                      ; scale up high digits
    sub edi,ecx                         ; subtract high digits from original. EDI now = lower 4 digits

    mul edx                             ; get first 2 digits in edx
    mov ecx,100                         ; load ready for later

    jnc next1                           ; if zero, supress them by ignoring
    cmp edx,9                           ; 1 digit or 2?
    ja  ZeroSupressed                   ; 2 digits, just continue with pairs of digits to the end

    mov edx,chartab[edx*4]              ; look up 2 digits
    mov [esi],dh                        ; but only write the 1 we need, supress the leading zero
    add esi, 1
    jmp ZS1                             ; continue with pairs of digits to the end

  next1:
    mul ecx                             ; get next 2 digits
    jnc next2                           ; if zero, supress them by ignoring
    cmp edx,9                           ; 1 digit or 2?
    ja  ZS1a                            ; 2 digits, just continue with pairs of digits to the end

    mov edx,chartab[edx*4]              ; look up 2 digits
    mov [esi],dh                        ; but only write the 1 we need, supress the leading zero
    add esi, 1
    jmp ZS2                             ; continue with pairs of digits to the end

  next2:
    mul ecx                             ; get next 2 digits
    jnc short next3                     ; if zero, supress them by ignoring
    cmp edx,9                           ; 1 digit or 2?
    ja  ZS2a                            ; 2 digits, just continue with pairs of digits to the end
     
    mov edx,chartab[edx*4]              ; look up 2 digits
    mov [esi],dh                        ; but only write the 1 we need, supress the leading zero
    add esi, 1
    jmp ZS3                             ; continue with pairs of digits to the end

  next3:

  skiphighdigits:
    mov eax,edi                         ; get lower 4 digits

    mov ecx,100

    mov edx,28F5C29h                    ; 2^32\100 +1
    mul edx
    jnc next4                           ; if zero, supress them by ignoring
    cmp edx,9                           ; 1 digit or 2?
    ja  ZS3a                            ; 2 digits, just continue with pairs of digits to the end

    mov edx,chartab[edx*4]              ; look up 2 digits
    mov [esi],dh                        ; but only write the 1 we need, supress the leading zero
    add esi, 1
    jmp  ZS4                            ; continue with pairs of digits to the end

    next4:
    mul ecx                             ; this is the last pair so don; t supress a single zero
    cmp edx,9                           ; 1 digit or 2?
    ja  ZS4a                            ; 2 digits, just continue with pairs of digits to the end

    mov edx,chartab[edx*4]              ; look up 2 digits
    mov [esi],dh                        ; but only write the 1 we need, supress the leading zero
    mov byte ptr [esi+1],0              ; zero terminate string

    jmp  xit                            ; all done

  ZeroSupressed:
    mov edx,chartab[edx*4]              ; look up 2 digits
    mov [esi],dx
    add esi,2                           ; write them to answer

  ZS1:
    mul ecx                             ; get next 2 digits
    ZS1a:
    mov edx,chartab[edx*4]              ; look up 2 digits
    mov [esi],dx                        ; write them to answer
    add esi,2

  ZS2:
    mul ecx                             ; get next 2 digits
    ZS2a:
    mov edx,chartab[edx*4]              ; look up 2 digits
    mov [esi],dx                        ; write them to answer
    add esi,2

  ZS3:
    mov eax,edi                         ; get lower 4 digits
    mov edx,28F5C29h                    ; 2^32\100 +1
    mul edx                             ; edx= top pair
    ZS3a:
    mov edx,chartab[edx*4]              ; look up 2 digits
    mov [esi],dx                        ; write to answer
    add esi,2                           ; update pointer

  ZS4:
    mul ecx                             ; get final 2 digits
    ZS4a:
    mov edx,chartab[edx*4]              ; look them up
    mov [esi],dx                        ; write to answer

    mov byte ptr [esi+2],0              ; zero terminate string

  xit:
  sdwordend:

    pop edi
    pop esi

    ret 8
ltoa_exHutch endp
ltoa_exHutch_endp:


a16
align 16
ltoa_exLingo_s:
ltoa_exLingo proc ; LongVar:DWORD,answer:DWORD
;db 0cch
	mov	   eax,	[esp+1*4]		; eax->number
   	mov	   edx,	0D1B71759h	; =2^45\10000    13 bit extra shift
 	mov	   ecx,	[esp+2*4]		; ecx-> lpResult
    test	   eax,eax                    ;  test sign
    jns	   @f                            ; if +ve, continue as for unsigned
    mov	    byte ptr [ecx],"-"   ;  include the - sign
    inc		ecx			                 ; update the pointer
    neg		eax                           ; else, make number positive
 @@:											; unsigned
	mov	  [esp+1*4], edi		    	; save edi
	mov	  edi,	eax						; save a copy of the number
	mov   [esp+2*4], esi		    	; save esi
 	mul	  edx								; gives 6 high digits in edx
	shr	  edx,	13						; correct for multiplier offset used to give better accuracy
	mov	  eax,	68DB9h		    	; =2^32\10000+1
	je		  LoNext3				 	    ; if zero then dont need to process the top 6 digits
	imul	  esi,	edx, 10000	
	sub	  edi,	esi	
	mul	  edx		
	mov	  esi,	100	
	jnc	  LoNext1	
	cmp	  edx,	9	
	jc       Lo0
	movzx	edx,	word ptr chartabL[edx+edx]	 
	add    ecx, 8      
	mov   [ecx-8], edx
Lo1:				
	mul	esi	 
Lo1a:			
	movzx	edx,	word ptr chartabL[edx+edx]	 
	mov	[ecx-6], edx	 
Lo2:				
	mul	esi		 
Lo2a:				
	movzx	edx,	word ptr chartabL[edx+edx]	 
	mov	[ecx-4], edx	 
Lo3:				
	mov	eax,	28F5C29h	 
	mul	edi		 
Lo3a:				
	movzx	edx,	word ptr chartabL[edx+edx]	 
	mov	[ecx-2], edx	 
Lo4:				
	mul	esi		 
Lo4a:				
	movzx	edx,	 word ptr chartabL[edx+edx]	 
	pop	eax		
	lea	eax,	[ecx+2]	
	pop	edi		
	mov	[ecx], 	edx	 
	pop	esi		
	jmp	dword ptr [esp-3*4]
Lo0:										
    add	ecx,	7
	add	edx,	30h	
	mov	[ecx-7],  edx	
	jne	Lo1	
LoNext1:			
	mul	esi		 
	jnc	@f		 
	add	ecx, 6	
	cmp	edx,	9	 
	ja		Lo1a		 
	add	edx,	30h	
	sub	ecx,	1	 
	mov	[ecx-5],  edx	 
	jnz	Lo2		 
@@:				
	mul	esi		 
	jnc	LoNext3		 
	add	ecx, 	4	
	cmp	edx,	9	
	ja		Lo2a		 
	add	edx,	30h	
	sub	ecx,	1	 
	mov	[ecx-3],  edx	 
	jnz	Lo3		 
LoNext3:			
	mov	eax,	28F5C29h 
	mul	edi		; 
	mov	esi,	100	;
	jnc	@f		; 
	add	ecx, 	2	;
	cmp	edx,	9	; 
	ja		Lo3a		; 
	add	edx,	30h	;
	sub	ecx,	1	; 
	mov	[ecx-1],   edx	; 
	jnz	Lo4		; 
@@:				;
	mul	esi		; 
	cmp	edx,	9	; 
	ja		Lo4a		; 
	add	edx,	30h	;
	pop	eax		;
	lea	eax,	[ecx+1]	;
	pop	edi		;
	mov	[ecx], 	edx	; 
	pop	esi		;
	jmp	dword ptr [esp-3*4]
ltoa_exLingo endp
ltoa_exLingo_endp:

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

end start


